Форум программистов, компьютерный форум, киберфорум
Наши страницы
С++ для начинающих
Войти
Регистрация
Восстановить пароль
 
mat_for_c
210 / 205 / 76
Регистрация: 26.04.2013
Сообщений: 957
Завершенные тесты: 3
#1

try . catch - C++

27.09.2013, 20:46. Просмотров 688. Ответов 11
Метки нет (Все метки)

можно ли провести данную операцию для функции erase у вектора??? пытался, что-то не получилось:
http://www.cyberforum.ru/cpp-beginners/thread2143401.html
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
#include <vector>
#include <algorithm>
#include <exception>
#include<iostream>
 
using namespace std;
 
void main() {
    vector<int> qw;
    qw.push_back(3);
    try{
        qw.erase(find(qw.begin(),qw.end(), 4)); // это соответствует qw.erase(qw.end());
    }
    catch(exception& exc)
    {
        cout << "exception";
    }
 
    system("pause");
}
все равно вылетает...
0
Надоела реклама? Зарегистрируйтесь и она исчезнет полностью.
Similar
Эксперт
41792 / 34177 / 6122
Регистрация: 12.04.2006
Сообщений: 57,940
27.09.2013, 20:46
Я подобрал для вас темы с готовыми решениями и ответами на вопрос try . catch (C++):

TRY/CATCH
Здравствуйте! У меня есть: MASS; для простоты пояснения,...

Try-catch
Добрый вечер, #include &lt;iostream&gt; using namespace std; void F1(int);...

try-catch
Доброго времени суток, начал изучать исключения, и вот есть такой код: //...

Try и catch
Пытался сделать простую структуру,чтобы в блоке try задавалось значение...

Try catch
try { throw pDoc-&gt;C; } catch (City) { return; } есть...

11
alsav22
5438 / 4833 / 831
Регистрация: 04.06.2011
Сообщений: 13,587
27.09.2013, 21:11 #2
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
#include <vector>
#include <algorithm>
#include <exception>
#include<iostream>
 
using namespace std;
 
int main() 
{
    vector<int> qw;
    qw.push_back(3);
    try
    {
        vector<int>::iterator it = find(qw.begin(), qw.end(), 4);
        if (it != qw.end())
        {
            qw.erase(it);
        }
        else throw out_of_range("");
    }
    catch(const out_of_range &exc)
    {
        cerr << "exception" << endl;
    }
 
    system("pause");
    return 0;
}
1
mat_for_c
210 / 205 / 76
Регистрация: 26.04.2013
Сообщений: 957
Завершенные тесты: 3
27.09.2013, 21:16  [ТС] #3
о как! спасибо большое

Добавлено через 1 минуту
Цитата Сообщение от alsav22 Посмотреть сообщение
C++
1
2
3
4
5
if (it != qw.end())
{
   qw.erase(it);
}
else throw out_of_range("");
а тогда по сути можно и try не писать???
0
monolit
188 / 187 / 46
Регистрация: 24.03.2011
Сообщений: 670
Завершенные тесты: 1
27.09.2013, 21:19 #4
попробуй catch(...), все отлавливает...
0
alsav22
5438 / 4833 / 831
Регистрация: 04.06.2011
Сообщений: 13,587
27.09.2013, 21:19 #5
Цитата Сообщение от mat_for_c Посмотреть сообщение
а тогда по сути можно и try не писать???
Тогда это уже не обработка исключений будет.
0
mat_for_c
210 / 205 / 76
Регистрация: 26.04.2013
Сообщений: 957
Завершенные тесты: 3
27.09.2013, 21:24  [ТС] #6
Цитата Сообщение от monolit Посмотреть сообщение
catch(...)
пробовал... как-то не захотел ловить

Добавлено через 2 минуты
Цитата Сообщение от alsav22 Посмотреть сообщение
Тогда это уже не обработка исключений будет.
просто в else написать вывод excption и все. результат будет одинаков... разве нет?
0
alsav22
5438 / 4833 / 831
Регистрация: 04.06.2011
Сообщений: 13,587
27.09.2013, 21:26 #7
Цитата Сообщение от mat_for_c Посмотреть сообщение
пробовал... как-то не захотел ловить
Чтобы ловил, нужно вбрасывать, а где у вас был вброс (throw)?

Добавлено через 1 минуту
Цитата Сообщение от mat_for_c Посмотреть сообщение
просто в else написать вывод excption и все. результат будет одинаков... разве нет?
Цитата Сообщение от alsav22 Посмотреть сообщение
Тогда это уже не обработка исключений будет.
Обработка исключений - особый механизм. Почитайте что-нибудь на эту тему.
0
mat_for_c
210 / 205 / 76
Регистрация: 26.04.2013
Сообщений: 957
Завершенные тесты: 3
27.09.2013, 21:28  [ТС] #8
Цитата Сообщение от alsav22 Посмотреть сообщение
где у вас был вброс (throw)?
я его тоже пробовал... писал перед qw.erase(...); эффекта 0
0
Tulosba
:)
Эксперт С++
4746 / 3240 / 496
Регистрация: 19.02.2013
Сообщений: 9,046
27.09.2013, 21:40 #9
mat_for_c, зачем городить исключения, если можно писать без исключений?
0
alsav22
5438 / 4833 / 831
Регистрация: 04.06.2011
Сообщений: 13,587
27.09.2013, 21:45 #10
Цитата Сообщение от mat_for_c Посмотреть сообщение
я его тоже пробовал... писал перед qw.erase(...)
Писать мало, нужно же при определённом условии вбрасывать.
0
mat_for_c
210 / 205 / 76
Регистрация: 26.04.2013
Сообщений: 957
Завершенные тесты: 3
27.09.2013, 21:50  [ТС] #11
Цитата Сообщение от Tulosba Посмотреть сообщение
если можно писать без исключений
на самом деле... зачем?
0
Tulosba
:)
Эксперт С++
4746 / 3240 / 496
Регистрация: 19.02.2013
Сообщений: 9,046
27.09.2013, 22:03 #12
Цитата Сообщение от mat_for_c Посмотреть сообщение
на самом деле... зачем?
Судя по Вашему коду из сообщения #1, понимания что такое исключения и с чем их едят - нет.
Попытка удалить элемент из вектора через итератор на конец вектора не бросает исключение, а приводит к undefined behavior. Поэтому и что-либо перехватить не получится, так как никакого исключения не было. Ситуации, подобные Вашей нужно обрабатывать иначе. В данном случае проверить возврат std::find, и если он вернул v.end(), то элемент не найден, и удалять ничего не надо. Решается всё обычным if'ом.
1
27.09.2013, 22:03
MoreAnswers
Эксперт
37091 / 29110 / 5898
Регистрация: 17.06.2006
Сообщений: 43,301
27.09.2013, 22:03
Привет! Вот еще темы с решениями:

try catch
Здравствуйте. В c++ новичёк, с try catch никогда толком не работал, а тут...

try-catch
Читаю книгу Страуструпа. Он пишет (стр 232), что можно не передавать...

try-catch
Какой тип проекта создавать в Visual Studio чтобы можно было сделать обработку...

Блок try-catch
В некоторых программах он хорошо работает и в блоке catch выводит то что...


Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
12
Ответ Создать тему
Опции темы

КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin® Version 3.8.9
Copyright ©2000 - 2018, vBulletin Solutions, Inc.
Рейтинг@Mail.ru